/*=============================================================================
	This is not supposed to build and should only be used for learning purposes
=============================================================================*/

//The actual context is a generic UObject, not a UXC_GameEngine object
void UXC_GameEngine::NewMapName(FFrame &Stack, RESULT_DECL)
{
	guard( UXC_GameEngine::NewMapName );
	P_GET_STR( NameEnding);
	P_GET_STR( MapName);
	P_GET_INT( Dir);
	P_FINISH;

	for ( TObjectIterator<UXC_GameEngine> Xg; Xg; ++Xg )
		break;

	if ( MapCache.Num() == 0 || (MapCachedPrefix != NameEnding) )
	{
		MapCachedPrefix = NameEnding;
		if ( Xg->bEnableDebugLogs )
			debugf( (EName)XC_ENGINE_XC_Engine.GetIndex(), TEXT("MapCache needs reloading...") );

		for ( int iP=0 ; iP<GSys->Paths.Num() ; iP++ )
		{
			if ( appStricmp( *(GSys->Paths(iP).Right(5)), TEXT("*.unr") ) == 0 )
			{
				FString RootDir = GSys->Paths(iP).Left( GSys->Paths(iP).Len() - 5);
				TArray<FString> Files = GFileManager->FindFiles( *(RootDir + NameEnding + TEXT("*.unr") ), true, false);
				if ( Xg->bSortMaplistByFolder )
					SortStrings( &Files );
				if ( Xg->bEnableDebugLogs )
					debugf( (EName)XC_ENGINE_XC_Engine.GetIndex(), TEXT("Searching through directory %s => Found %i results"), *RootDir, Files.Num() );
				int OldSize = MapCache.Num();
				MapCache.AddZeroed( Files.Num() );
				for ( int iM = 0 ; iM < Files.Num() ; iM++ )
					MapCache( OldSize + iM) = Files(iM);
			}
		}
		if ( Xg->bSortMaplistGlobal )
			SortStrings( &MapCache );

	}
	if ( MapCache.Num() > 0 )
	{
		if ( !MapName.Len() )
			LastMapIdx = 0;
		else if ( MapCache(LastMapIdx) == MapName ) //Chained search
			LastMapIdx += Dir;
		else
		{
			for ( int i = 0 ; i<MapCache.Num() ; i++ )
				if ( MapCache(i) == MapName )
				{
					LastMapIdx = i + Dir;
					break;
				}
		}
	
		while ( LastMapIdx >= MapCache.Num() )
			LastMapIdx -= MapCache.Num();
		while ( LastMapIdx < 0 )
			LastMapIdx += MapCache.Num();
		*(FString*)Result = MapCache( LastMapIdx );
	}
	unguard;
}
IMPLEMENT_FUNCTION( UXC_GameEngine,-1,NewMapName);

void UXC_GameEngine::SortStrings( TArray<FString>* List)
{
	FString Store;
	for ( INT i=1 ; i<List->Num() ; i++ )
	{
		if ( appStricmp( *(*List)(i), *(*List)(i-1)) < 0 )
		{
			Store = (*List)(i-1);
			(*List)(i-1) = (*List)(i);
			(*List)(i) = Store;
			if ( i == 1 )
				continue;
			i -= 2;
		}
	}
}

//DO NOT CALL IF THERE'S NO ENTRY LEVEL
void UXC_GameEngine::CleanupTransientRefs()
{
	guard( UXC_GameEngine::CleanupTransientRefs);
	FTransientClassMap ClassMap(0);
	ULevel* EntryLevel = GetEntryLevel(this);
	ULevel* ActiveLevel = GetActiveLevel(this);

	if ( !ActiveLevel || (ActiveLevel == EntryLevel) )
		return;

	INT ScriptedTexIdx = ClassMap.RegisterClass( UScriptedTexture::StaticClass() );
	INT Idx = 0;

	for ( TObjectIterator<UObject> It; It; ++It )
	{
		if ( It->GetOuter() )
		{
			if ( It->IsA(UScriptedTexture::StaticClass()) )
				Idx = ScriptedTexIdx;
			else
			{
				Idx = 0;
				UObject* TheOuter = It->GetOuter();
				while ( TheOuter && (TheOuter->GetOuter() != TheOuter) )
				{
					if ( (TheOuter == GetTransientPackage()) || (EntryLevel && (TheOuter == EntryLevel)) )
					{
						Idx = ClassMap.RegisterClass( It->GetClass() );
						break;
					}
					TheOuter = TheOuter->GetOuter();
				}
			}
			if ( ClassMap(Idx).TotalProps <= 0 )
				continue;
//			if ( Idx > 0 )
//				debugf( NAME_Log, TEXT("[XCGE]--- Scanning object %s"), It->GetName() );
			while ( Idx > 0 )
			{
				for ( int i=0 ; i<ClassMap(Idx).Properties.Num() ; i++ )
				{
					UProperty* Prop = ClassMap(Idx).Properties(i);
//					debugf( NAME_Log, TEXT("[XCGE]---- Scanning property %s"), Prop->GetName() );
					check( Prop);
					UObject* TheObj = *It;
					AActor** Ref = (AActor**) ( DWORD (TheObj) + Prop->Offset);
					for ( int j=0 ; j<Prop->ArrayDim ; j++ )
					{
						if ( *Ref && ((*Ref)->GetOuter() == ActiveLevel->GetOuter() ) )
						{
							if ( bEnableDebugLogs )
								debugf( (EName)XC_ENGINE_XC_Engine.GetIndex(), TEXT("[WARNING] Dangerous actor reference held by %s: %s[%i]=%s, nulling out."), It->GetFullName(), Prop->GetName(), j, (*Ref)->GetFullName() );
							*Ref = NULL;
						}
						Ref++;
					}
				}
				Idx = ClassMap(Idx).ParentIdx;
			}
		}
	}

	unguard;
}


INT FTransientClassMap::RegisterClass( UClass* InClass) //Return index in map
{
	guard(FTransientClassMap::RegisterClass);
	if ( !ArrayNum )
	{
		AddZeroed();
		(*this)(0).ParentIdx = -1;
		(*this)(0).Class = UObject::StaticClass();
		if ( InClass == UObject::StaticClass() )
			return 0;
	}
	//Find direct subclasses, register whatever's necessary
	UClass* Parent = UObject::StaticClass();
	INT ParentIdx = 0;
	while ( Parent )
	{
		UBOOL Found = 0;
		UClass* CurClass = InClass;
		if ( CurClass == Parent ) //Cur has been added!
			break;
		while ( CurClass->GetSuperClass() != Parent )
			CurClass = CurClass->GetSuperClass();
		//This class's parent is obviously on this list, attempt to find using parent's children array
		for ( int i=0 ; i< (*this)(ParentIdx).ChildrenIdx.Num() ; i++ )
		{
			if ( (*this)( (*this)(ParentIdx).ChildrenIdx(i) ).Class == CurClass ) //This class is listed on parent's children, do not register
			{
				Found = 1;
				ParentIdx = (*this)(ParentIdx).ChildrenIdx(i);
				break;
			}
		}
		//Register this class if necessary
		if ( !Found )
		{
			AddZeroed();
			Last().Class = CurClass;
			Last().Idx = ArrayNum - 1;
			Last().ParentIdx = ParentIdx;
			Last().TotalProps = (*this)(ParentIdx).TotalProps;
			(*this)(ParentIdx).ChildrenIdx.Add();
			(*this)(ParentIdx).ChildrenIdx.Last() = Last().Idx; //Add the new child IDX (this) onto the parent
			
//			debugf( NAME_Log, TEXT("[XCGE] Registering class %s"), CurClass->GetName() );

			UField* Field = CurClass->Children;
			//Exceptions!
			if ( !CurClass->IsChildOf(UPlayer::StaticClass()) && !CurClass->IsChildOf(USubsystem::StaticClass()) )
			{
				while ( Field ) //Find Actor references
				{
					if ( Field->IsA( UObjectProperty::StaticClass()) && !(((UProperty*)Field)->PropertyFlags & CPF_Native) && ((UObjectProperty*)Field)->PropertyClass->IsChildOf(AActor::StaticClass() ) ) //Do not list native props
					{
//						debugf( NAME_Log, TEXT("[XCGE]-- Registering actor property %s"), Field->GetName() );
						Last().Properties.AddZeroed();
						Last().Properties.Last() = (UProperty*) Field;
						Last().TotalProps++;
					}
					Field = Field->Next;
				}
			}
			ParentIdx = Last().Idx;
		}
		Parent = CurClass;
	}
	return ParentIdx;
	unguard;
}

//==============================================================================
// FCollisionCacus experiment
//==============================================================================
void UXC_GameEngine::SetupCollisionCacus( ULevel* Lev)
{
	guard( UXC_GameEngine::SetupCollisionCacus);
	if ( !bXC_Init || !Lev || !Lev->Hash || (Lev->Hash == CollisionCacus) )
		return;
	if ( !CollisionCacus )
	{
		if ( Lev->GetOuter() )
			debugf( (EName)XC_ENGINE_XC_Engine.GetIndex(), TEXT("Setting up collision octree for %s"), Lev->GetOuter()->GetName() );

		CollisionCacus = new FCollisionCacus;
		guard( LevelBox);
		//THIS WILL SUCK ON 227'S ADDITIVE LEVELS!
		if ( Lev->Model->Points.Num() )
		{
			FBox LBox = FBox( &Lev->Model->Points(0), Lev->Model->Points.Num() );
			LBox.Min -= FVector( 64, 64, 64);
			LBox.Max += FVector( 64, 64, 64);
			CollisionCacus->BoundingBox = LBox;
			CollisionCacus->CenterPoint = (LBox.Max+LBox.Min) * 0.5;
			if ( bEnableDebugLogs )
				debugf( (EName)XC_ENGINE_XC_Engine.GetIndex(), TEXT("Altered octree box to (%i,%i,%i)(%i,%i,%i)"), (INT)LBox.Min.X, (INT)LBox.Min.Y, (INT)LBox.Min.Z, (INT)LBox.Max.X, (INT)LBox.Max.Y, (INT)LBox.Max.Z );
		}
		unguard;
		CollisionCacus->SetupGrids();
		guard( AddActors);
		for( INT i=0 ; i<Lev->Actors.Num() ; i++ )
			if( Lev->Actors(i) && !Lev->Actors(i)->bDeleteMe && Lev->Actors(i)->bCollideActors )
			{
				Lev->Hash->RemoveActor( Lev->Actors(i) );
				CollisionCacus->AddActor( Lev->Actors(i) );
			}
		unguard;
	}
	CollisionCacus->Hooked = Lev->Hash;
	Lev->Hash = CollisionCacus;
	unguard;
}

void UXC_GameEngine::DeleteCollisionCacus( ULevel* Lev)
{
	guard( UXC_GameEngine::DeleteCollisionCacus);
	if ( !CollisionCacus )
		return;
	if ( Lev && CollisionCacus->Hooked )
		Lev->Hash = CollisionCacus->Hooked;
	delete CollisionCacus;
	CollisionCacus = NULL;
	unguard;
}


//==============================================================================
// Dummy Pawn functions and hooks
//==============================================================================

//Called on PlayerPawn context
void AXC_DummyPawn::AdminLoginNative(FFrame &Stack, RESULT_DECL)
{
	guard( AdminLoginNative );
	P_GET_OBJECT(APlayerPawn,P);
	P_FINISH;
	*(UBOOL*)Result = 1;
	if ( P )
	{
		UXC_GameEngine* Xg = Cast<UXC_GameEngine>(XLevel->Engine);
		if ( Xg && Xg->AdminLoginHook )
		{
			UHack_eventAdminLoginHook_Parms Parms;
			Parms.P = P;
			Parms.ReturnValue = 0;
			Xg->AdminLoginHook->ProcessEvent( Xg->AdminLoginHook->FindFunctionChecked(XC_ENGINE_AdminLoginHook),&Parms);
			*(UBOOL*)Result = Parms.ReturnValue;
		}
	}
	unguard;
}

//Called on GameInfo context
void AXC_DummyPawn::PreLoginNative(FFrame &Stack, RESULT_DECL)
{
	guard( PreLoginNative );
	P_GET_STR( Options);
	P_GET_STR( Address);
	P_GET_STR_REF( Error);
	P_GET_STR_REF( FailCode);
	P_FINISH;
	
	UXC_GameEngine* Xg = Cast<UXC_GameEngine>(XLevel->Engine);
	if ( Xg )
		Xg->ProcessPreLoginHooks( Options, Address, *Error, *FailCode);
	
	unguard;
}
//IMPLEMENT_FUNCTION( UXC_GameEngine,-1,PreLoginNative);

//Called mostly on Actor context
void AXC_DummyPawn::NewPlayerCanSeeMe(FFrame &Stack, RESULT_DECL)
{
	guard( XC_Engine::NewPlayerCanSeeMe);
	P_FINISH;

	*(UBOOL*)Result = 0;
	if ( XLevel )
	{
		if ( XLevel->Engine->Client && XLevel->Engine->Client->Viewports.Num() && XLevel->Engine->Client->Viewports(0) && XLevel->Engine->Client->Viewports(0)->Actor ) //Local player
			if ( PCanSee( XLevel->Engine->Client->Viewports(0)->Actor) )
			{
				*(UBOOL*)Result = 1;
				return;
			}
		if ( XLevel->NetDriver && XLevel->NetDriver->ClientConnections.Num() ) //Clients
		{
			for ( INT ip=0 ; ip < XLevel->NetDriver->ClientConnections.Num() ; ip++ )
				if ( XLevel->NetDriver->ClientConnections(ip) && XLevel->NetDriver->ClientConnections(ip)->Actor )
					if ( PCanSee( XLevel->NetDriver->ClientConnections(ip)->Actor) )
					{
						*(UBOOL*)Result = 1;
						return;
					}
		}
	}

	unguard;
}

UBOOL AXC_DummyPawn::PCanSee( APlayerPawn* Other)
{
	guard( XC_Engine::PCanSee);
	check( Other);
	FVector aVec = Location - Other->Location;
	if ( aVec.IsZero() )
		return 0;
	if ( aVec.SizeSquared() > 2560000 )
		return 0;
	if ( aVec.SizeSquared() > (aVec + Other->ViewRotation.Vector()).SizeSquared() )
		return 0;
	if ( !aVec.Normalize() )
		return 0;
	FLOAT aFov = Other->FovAngle / 114.6; //Real angle outside of the center
	FLOAT aDot = aVec|Other->ViewRotation.Vector(); //This is the cosine of our angle
	if ( aDot < appCos(aFov * 1.2) )
		return 0;
	FCheckResult Hit;
	return XLevel->SingleLineCheck( Hit, this, Location, Other->Location + FVector(0,0,Other->BaseEyeHeight), TRACE_Level, FVector(0,0,0), 0|NF_NotVisBlocking);
	unguard;
}

void AXC_DummyPawn::NewDynArrayElement( FFrame& Stack, RESULT_DECL )
{
	// Grab the index
	INT Index=0;
	Stack.Step( Stack.Object, &Index );

	// Grab the property
	GProperty = NULL;
	Stack.Step( this, NULL );

	if( GProperty && GPropAddr )
	{
		FArray* Array=(FArray*)GPropAddr;
		UArrayProperty* ArrayProp = (UArrayProperty*)GProperty;
		if( Index>=Array->Num() || Index<0 )
		{
			//if we are returning a value, check for out-of-bounds
			if ( Result || Index<0 )
			{
				Stack.Logf( NAME_Error, TEXT("Accessed array '%s' out of bounds (%i/%i)"), ArrayProp->GetName(), Index, Array->Num() );
				GPropAddr = 0;
				if (Result)
					appMemzero( Result, ArrayProp->Inner->ElementSize );
				return;
			}
			//if we are setting a value, allow the array to be resized
			else
				Array->AddZeroed(ArrayProp->Inner->ElementSize,Index-Array->Num()+1);
		}
		GPropAddr = (BYTE*)Array->GetData() + Index * ArrayProp->Inner->ElementSize;

		// Add scaled offset to base pointer.
		if( Result )
			ArrayProp->Inner->CopySingleValue( Result, GPropAddr );
	}
}

void AXC_DummyPawn::NewDynArrayLength( FFrame& Stack, RESULT_DECL )
{
	GProperty = NULL;
	Stack.Step( this, NULL );
	UBOOL bSetSize = false;
	INT NewSize = 0;
	if ( *(Stack.Code) != EX_EndFunctionParms )
	{
		Stack.Step( Stack.Object, &NewSize);
		if ( GProperty->PropertyFlags & CPF_Const )
			debugf( NAME_ScriptWarning, TEXT("Set length of Dynamic Array '%s' marked as 'const'"), GProperty->GetName() );
		else if ( NewSize < 0 )
			debugf( NAME_ScriptWarning, TEXT("Set length of Dynamic Array '%s' to a negative size: %i"), GProperty->GetName(), NewSize );
		else
			bSetSize = true;
	}
	P_FINISH;

	if (GPropAddr && GProperty)
	{
		FArray* Array=(FArray*)GPropAddr;
		UArrayProperty* ArrayProp = (UArrayProperty*)GProperty;
		if ( bSetSize )
		{
			if ( NewSize > Array->Num() )
				Array->AddZeroed(ArrayProp->Inner->ElementSize, NewSize-Array->Num());
			else if (NewSize < Array->Num())
			{
				for (INT i=Array->Num()-1; i>=NewSize; i--)
					ArrayProp->Inner->DestroyValue((BYTE*)Array->GetData() + ArrayProp->Inner->ElementSize*i);
				Array->Remove(NewSize, Array->Num()-NewSize, ArrayProp->Inner->ElementSize );
			}
		}
		*(INT*)Result = Array->Num();
	}
}

void AXC_DummyPawn::NewDynArrayInsert( FFrame& Stack, RESULT_DECL )
{
	GProperty = NULL;
	Stack.Step( this, NULL );
	UArrayProperty* ArrayProperty = Cast<UArrayProperty>(GProperty);
	FArray* Array=(FArray*)GPropAddr;

	P_GET_INT(Index);
	P_GET_INT_OPTX(Count,1);
	P_FINISH;

	if ( ArrayProperty->PropertyFlags & CPF_Const )
		debugf( NAME_ScriptWarning, TEXT("Insert in Dynamic Array '%s' marked as 'const'"), ArrayProperty->GetName() );
	else if (Array && Count)
	{
		if ( Count < 0 )
		{
			Stack.Logf( TEXT("Attempt to insert a negative number of elements '%s'"), ArrayProperty->GetName() );
			return;
		}
		if ( Index < 0 || Index > Array->Num() )
		{
			Stack.Logf( TEXT("Attempt to insert %i elements at %i an %i-element array '%s'"), Count, Index, Array->Num(), ArrayProperty->GetName() );
			Index = Clamp(Index, 0,Array->Num());
		}
		Array->InsertZeroed( Index, Count, ArrayProperty->Inner->ElementSize);
		*(UBOOL*)Result = true;
	}
}

void AXC_DummyPawn::NewDynArrayRemove( FFrame& Stack, RESULT_DECL )
{	
	GProperty = NULL;
	Stack.Step( this, NULL );
	UArrayProperty* ArrayProperty = Cast<UArrayProperty>(GProperty);
	FArray* Array=(FArray*)GPropAddr;

	P_GET_INT(Index);
	P_GET_INT_OPTX(Count, 1);
	P_FINISH;
	if ( ArrayProperty->PropertyFlags & CPF_Const )
		debugf( NAME_ScriptWarning, TEXT("Remove in Dynamic Array '%s' marked as 'const'"), ArrayProperty->GetName() );
	else if (Array && Count)
	{
		if ( Count < 0 )
		{
			Stack.Logf( TEXT("Attempt to remove a negative number of elements '%s'"), ArrayProperty->GetName() );
			return;
		}
		if ( Index < 0 || Index >= Array->Num() || Index + Count > Array->Num() )
		{
			if (Count == 1)
				Stack.Logf( TEXT("Attempt to remove element %i in an %i-element array '%s'"), Index, Array->Num(), ArrayProperty->GetName() );
			else
				Stack.Logf( TEXT("Attempt to remove elements %i through %i in an %i-element array '%s'"), Index, Index+Count-1, Array->Num(), ArrayProperty->GetName() );
			Index = Clamp(Index, 0,Array->Num());
			if ( Index + Count > Array->Num() )
				Count = Array->Num() - Index;
		}

		for (INT i=Index+Count-1; i>=Index; i--)
			ArrayProperty->Inner->DestroyValue((BYTE*)Array->GetData() + ArrayProperty->Inner->ElementSize*i);
		Array->Remove( Index, Count, ArrayProperty->Inner->ElementSize);
		*(UBOOL*)Result = true;
	}
}

void AXC_DummyPawn::NewAppSeconds( FFrame& Stack, RESULT_DECL )
{
	P_FINISH;
	*(FLOAT*)Result = appSeconds().GetFloat();
}

void AXC_DummyPawn::NewMakeColor( FFrame& Stack, RESULT_DECL )
{
	BYTE CData[4];
	Stack.Step( Stack.Object, &CData);
	Stack.Step( Stack.Object, &CData[1]);
	Stack.Step( Stack.Object, &CData[2]);
	if ( *Stack.Code != EX_EndFunctionParms )
		Stack.Step( Stack.Object, &CData[3]);
	else
		CData[3] = 0;
	P_FINISH;
	*(FColor*)Result = *( (FColor*) ((DWORD) &CData));
}
