
inline FLOAT _appInvSqrt( FLOAT F )
{
#if ASM
	const FLOAT fThree = 3.0f;
	const FLOAT fOneHalf = 0.5f;
	FLOAT temp;

	__asm
	{
		movss	xmm1,[F]
		rsqrtss	xmm0,xmm1			// 1/sqrt estimate (12 bits)

		// Newton-Raphson iteration (X1 = 0.5*X0*(3-(Y*X0)*X0))
		movss	xmm3,[fThree]
		movss	xmm2,xmm0
		mulss	xmm0,xmm1			// Y*X0
		mulss	xmm0,xmm2			// Y*X0*X0
		mulss	xmm2,[fOneHalf]		// 0.5*X0
		subss	xmm3,xmm0			// 3-Y*X0*X0
		mulss	xmm3,xmm2			// 0.5*X0*(3-Y*X0*X0)
		movss	[temp],xmm3
	}
	return temp;
#elif ASMLINUX
	//I NEED LINUX ASM HERE!!!
	return 1.0f / appSqrt( F);
#else
	return 1.0f / appSqrt( F);
#endif
}

inline FVector _UnsafeNormal( const FVector& V)
{
	const FLOAT Scale = _appInvSqrt(V.X*V.X+V.Y*V.Y+V.Z*V.Z);
	return FVector( V.X*Scale, V.Y*Scale, V.Z*Scale );
}

inline FVector _UnsafeNormal2D( const FVector& V)
{
	const FLOAT Scale = _appInvSqrt(V.X*V.X+V.Y*V.Y);
	return FVector( V.X*Scale, V.Y*Scale, 0.f);
}

inline FVector _UnsafeNormal2D( const FLOAT& X, const FLOAT& Y)
{
	const FLOAT Scale = _appInvSqrt(X*X+Y*Y);
	return FVector( X*Scale, Y*Scale, 0.f);
}
